type 'a t = int * int * 'a array

let array_of
    ((mr, mc, ma): 'a t)
    : 'a array =
  ma

let index_of
    ((mr, mc, ma): 'a t)
    ((r, c): int * int)
    : int =
  r * mc + c

let create 
    ((r, c): int * int)
    (a: 'a)
    : 'a t =
  (r, c, Array.create (r * c) a)

let get 
    (m: 'a t)
    ((r, c): int * int)
    : 'a =
  Array.get (array_of m) (index_of m (r, c))

let set 
    (m: 'a t)
    ((r, c): int * int)
    (a: 'a)
    : unit =
  Array.set (array_of m) (index_of m (r, c)) a
