let _ =
  let lexbuf = Lexing.from_channel stdin
  in
  let (s, v) = SUParser.main SULexer.token lexbuf
  in
  let problem = Sudoku.create s v
  in
  Sudoku.printProblem problem;
  Printf.printf "Solving...\n";
  match Sudoku.solve problem with
  | None          ->
      Printf.printf "No solution found.\n";
  | Some solution ->
      Printf.printf "Solution:\n";
      Sudoku.printSolution solution;
